#!/system/bin/sh
# Copyright (c) 2011, Code Aurora Forum. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Code Aurora nor
#       the names of its contributors may be used to endorse or promote
#       products derived from this software without specific prior written
#       permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

target=`getprop ro.product.device`
case "$target" in
	"msm7627a_sku1" | "msm7627a_sku3" | "msm7627a_sku5")
	logpath=`getprop persist.debug.logpath`
	logcat_level=`getprop persist.debug.ll`
	smem_level=`getprop persist.debug.sl`
	binder_level=`getprop persist.debug.bl`
	case $logpath in 
	"")
		logpath="/data/logs"
		;;
	esac
	case $logcat_level in
	"")
		logcat_level=0
		;;
	esac
	case $smem_level in
	"")
		smem_level=0
		;;
	esac
	case $binder_level in
	"")
		binder_level=0
		;;
	esac

	time=$(date +%Y%m%d%H%M%S)
	day=$(date +%-j)
	# 2 days ago
	prev_day=$((day - 6))

	case $logcat_level in
	0)
		logcat -v time -b main *:W >> /dev/kmsg &
		logcat -v time -b radio *:W >> /dev/kmsg &
		logcat -v time -b system *:W >> /dev/kmsg &
		logcat -v time -b events *:W >> /dev/kmsg &
		;;
	1)
		logcat -v time -b main *:I >> /dev/kmsg &
                logcat -v time -b radio *:I >> /dev/kmsg &
                logcat -v time -b system *:I >> /dev/kmsg &
                logcat -v time -b events *:I >> /dev/kmsg &
		;;
	2)
		logcat -v time -b main *:D >> /dev/kmsg &
                logcat -v time -b radio *:D >> /dev/kmsg &
                logcat -v time -b system *:D >> /dev/kmsg &
                logcat -v time -b events *:D >> /dev/kmsg &
                ;;
	3)
		logcat -v time -b main *:V >> /dev/kmsg &
                logcat -v time -b radio *:V >> /dev/kmsg &
                logcat -v time -b system *:V >> /dev/kmsg &
                logcat -v time -b events *:V >> /dev/kmsg &
                ;;
	esac

	case $smem_level in
	1)
		cat /mnt/debugfs/smem_log/dump_voters >> /dev/kmsg &
		cat /mnt/debugfs/smem_log/dump_sym_cont >> /dev/kmsg &
		;;
	2)
		cat /mnt/debugfs/smem_log/dump_voters >> /dev/kmsg &
		cat /mnt/debugfs/smem_log/dump_sym_cont >> /dev/kmsg &
                cat /mnt/debugfs/smem_log/dump_static_sym_cont >> /dev/kmsg &
		;;
	3)
		cat /mnt/debugfs/smem_log/dump_voters >> /dev/kmsg &
                cat /mnt/debugfs/smem_log/dump_sym_cont >> /dev/kmsg &
                cat /mnt/debugfs/smem_log/dump_static_sym_cont >> /dev/kmsg &
                cat /mnt/debugfs/smem_log/dump_power_sym_cont >> /dev/kmsg &
		;;
	esac

	case $logpath in
	"/dev/null")
		;;
	*)
		# write logs to flash
		i=0
		while true; do
			mkdir $logpath
			ls $logpath > /dev/null
			case "$?" in
			"0")
				break
				;;
			*)
				sleep 1
				i=$((i + 1))
				;;
			esac
			case "$i" in
			"60")
				exit 1
				;;
			esac
		done
		rm -r $logpath/logs-$target-$prev_day-*.log
		cat /proc/kmsg >> $logpath/logs-$target-$day-$time.log
		;;
	esac

	while true; do
		case $binder_level in
		0)
			cat /mnt/debugfs/binder/transaction_log >> /dev/kmsg &
			;;
		1)
			cat /mnt/debugfs/binder/transaction_log >> /dev/kmsg &
			cat /mnt/debugfs/binder/failed_transaction_log >> /dev/kmsg &
			cat /mnt/debugfs/binder/state >> /dev/kmsg &
			;;
		esac
		cat /mnt/debugfs/smd/modem_err >> /dev/kmsg &
		sleep 15
	done
	;;
esac
